#ifndef T_IOT_901_CONVOYOR_GUIWIDGET_H
#define T_IOT_901_CONVOYOR_GUIWIDGET_H

struct GuiWidgetPosition {
    int x;
    int y;
};

struct GuiWidgetSize {
    int width;
    int height;
};

namespace gui {
    class AGUIWidget {
    public:
        AGUIWidget(int x, int y, int width, int height, int layer = 0);
        ~AGUIWidget() = default;
        virtual const char* getName() const = 0;
        virtual void setup() = 0;
        virtual void update() = 0;
        int getLayer() const;
        void setLayer(int layer);
        GuiWidgetPosition getPosition() const;
        void setPosition(GuiWidgetPosition position);
        GuiWidgetSize getSize() const;
        void setSize(GuiWidgetSize size);
    private:
        GuiWidgetPosition position{};
        GuiWidgetSize size{};
        int layer;
    };
}

#endif //T_IOT_901_CONVOYOR_GUIWIDGET_H
